Draft Facebinder: Difference between revisions

From FreeCAD Documentation
(which is a list of SelectionObjects as returned by FreeCADGui.Selection.getSelectionEx().)
m ([[ | ]] (Vertical Docnav))
Line 2: Line 2:
<translate>
<translate>
<!--T:21-->
<!--T:21-->
{{Docnav
{{Docnav|[[Draft_ShapeString|ShapeString]]|[[Draft_BezCurve|Bezier Curve]]|[[Draft_Module|Draft]]|IconL=Draft_ShapeString.svg |IconC=Workbench_Draft.svg|IconR=Draft_BezCurve.svg }}
|[[Draft_ShapeString|ShapeString]]
|[[Draft_BezCurve|Bezier Curve]]
|[[Draft_Module|Draft]]
|IconL=Draft_ShapeString.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_BezCurve.svg
}}


<!--T:1-->
<!--T:1-->
Line 10: Line 17:
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Shortcut=F F
|Shortcut=F F
|SeeAlso=[[Part Box]], [[Arch Wall]]
|SeeAlso=[[Part Box|Part Box]], [[Arch Wall|Arch Wall]]
|Version=0.14
|Version=0.14
}}
}}
Line 50: Line 57:


=== View === <!--T:17-->
=== View === <!--T:17-->
* {{PropertyView|Pattern}}: specifies a [[Draft Pattern]] with which to fill the face of the shape. This property only works if {{PropertyView|Display Mode}} is "Flat Lines".
* {{PropertyView|Pattern}}: specifies a [[Draft Pattern|Draft Pattern]] with which to fill the face of the shape. This property only works if {{PropertyView|Display Mode}} is "Flat Lines".
* {{PropertyView|Pattern Size}}: specifies the size of the [[Draft Pattern]].
* {{PropertyView|Pattern Size}}: specifies the size of the [[Draft Pattern|Draft Pattern]].


==Scripting== <!--T:6-->
==Scripting== <!--T:6-->
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:7-->
<!--T:7-->
The Facebinder tool can be used in [[macros]] and from the [[Python]] console by using the following function:
The Facebinder tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 68: Line 75:
A {{incode|PropertyLinkSubList}} is a list of tuples; each tuple contains as first element an {{incode|object}}, and as second element a list (or tuple) of strings; these strings indicate the names of the sub-elements of that object.
A {{incode|PropertyLinkSubList}} is a list of tuples; each tuple contains as first element an {{incode|object}}, and as second element a list (or tuple) of strings; these strings indicate the names of the sub-elements of that object.

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 109: Line 117:


<!--T:20-->
<!--T:20-->
{{Docnav
{{Docnav|[[Draft_ShapeString|ShapeString]]|[[Draft_BezCurve|Bezier Curve]]|[[Draft_Module|Draft]]|IconL=Draft_ShapeString.svg |IconC=Workbench_Draft.svg|IconR=Draft_BezCurve.svg }}
|[[Draft_ShapeString|ShapeString]]
|[[Draft_BezCurve|Bezier Curve]]
|[[Draft_Module|Draft]]
|IconL=Draft_ShapeString.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_BezCurve.svg
}}


<!--T:22-->
<!--T:22-->

Revision as of 08:38, 25 October 2019

Draft Facebinder

Menu location
Draft → Facebinder
Workbenches
Draft, Arch
Default shortcut
F F
Introduced in version
0.14
See also
Part Box, Arch Wall

Description

The Facebinder tool creates a surface object from the selected faces of a solid object. It is parametric, meaning that if you modify the original object, the Facebinder updates accordingly. If you move and rotate the Facebinder, it will stay linked to the original faces.

It can be used to create an extrusion from a collection of faces from other objects. A typical use is in architectural design to build an object that covers several walls, for example, a wall paper, or wall finish.

Facebinder created from the faces of solid walls

How to use

  1. Pick one face, or hold Ctrl and pick several faces, from solid objects.
  2. Press the Facebinder button, or press F then F keys.

The Facebinder can be edited by double clicking on the element in the tree view. Then you can change the faces that are part of the object.

  • To add a face, click on a face of a solid object in the 3D view, and then click on the Add button.
  • To remove a face, select one of the sub-elements in the list, and then click on the Remove button.
  • Press Esc or the OK button to complete the edition.

Options

This object has no options when it's being created. Only selected faces will be used to create the Facebinder object.

Properties

Data

  • DataExtrusion: specifies an extrusion thickness to apply to all faces of the shape.
  • DataRemove Splitter: if it is true it tries to fuse the internal intersections of the Facebinder when it extruded.
  • DataSew: if it is true it tries to perform a topological sewing operation on the Facebinder when it extruded.

View

  • ViewPattern: specifies a Draft Pattern with which to fill the face of the shape. This property only works if ViewDisplay Mode is "Flat Lines".
  • ViewPattern Size: specifies the size of the Draft Pattern.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Facebinder tool can be used in macros and from the Python console by using the following function:

Facebinder = makeFacebinder(selectionset)
  • Creates a Facebinder object from the given selectionset, which is a list of SelectionObjects as returned by FreeCADGui.Selection.getSelectionEx(). Only selected faces are taken into account.
    • selectionset can also be a PropertyLinkSubList.

A PropertyLinkSubList is a list of tuples; each tuple contains as first element an object, and as second element a list (or tuple) of strings; these strings indicate the names of the sub-elements of that object.

PropertyLinkSubList = [tuple1, tuple2, tuple3, ...]
PropertyLinkSubList = [(object1, list1), (object2, list2), (object3, list3), ...]
PropertyLinkSubList = [(object1, ['Face1', 'Face4', 'Face6']), ...]
PropertyLinkSubList = [(object1, ('Face1', 'Face4', 'Face6')), ...]

The thickness of the Facebinder can be added by overwriting its Extrusion attribute; the value is entered in millimeters.

The placement of the Facebinder can be changed by overwriting its Placement attribute, or by individually overwriting its Placement.Base and Placement.Rotation attributes.

Example:

import FreeCAD
import FreeCADGui
import Draft

# Insert a solid box
Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 2300
Box.Width = 800
Box.Height = 1000

# selection = FreeCADGui.Selection.getSelectionEx()
selection = [(Box, ("Face1", "Face6"))]
Facebinder = Draft.makeFacebinder(selection)
Facebinder.Extrusion = 50
FreeCAD.ActiveDocument.recompute()

Facebinder.Placement.Base = FreeCAD.Vector(1000, -1000, 100)
Facebinder.ViewObject.ShapeColor = (0.99, 0.99, 0.4)